<?php

/*
 * Created by Greg Harvey on 5 Oct 2010
 *
 * http://www.drupaler.co.uk
 */

/**
 * Admin form function for Project API settings.
 */
function project_api_admin_settings() {
  $form = array();
  $implementations = array();
  $options = array();
  // Get available storage options.
  $implementations = module_invoke_all('project_api_info');
  
  // Build options for the storage selector.
  if (is_array($implementations['module'])) {
    foreach ($implementations['module'] as $key => $module) {
      // Check module implements the correct API version.
      if ($implementations['api version'][$key] == 1) {
        $options[$module] = $implementations['name'][$key];
      }
      else {
        drupal_set_message(t('Warning: the %module module does not use the correct API for this version of Project API.', array('%module' => $module)), 'error', FALSE);
      }
    }
  }
  // Returned elements are not an array.
  else {
    // Check module implements the correct API version.
    if ($implementations['api version'] == 1) {
      $options[$implementations['module']] = $implementations['name'];
    }
  }
  
  // Build the repository type selector.
  if ($options) {
    $form['project_api_repository_settings'] = array(
      '#title' => t('Repository settings'),
      '#description' => t('Select which module the Project API module should use to get project data.'),
      '#type' => 'select',
      // Disable by default, enable later if there's more than one option.
      '#disabled' => TRUE,
      '#options' => $options,
      // Value is the module name to be used for storage.
      '#default_value' => variable_get('project_api_repository', 'project_api_drupal'),
    );
    if (count($options) > 1) {
      $form['project_api_repository_settings']['#disabled'] = FALSE;
    }
  }
  // No repository module is enabled.
  else {
    drupal_set_message(t('You must enable at least one repository module. If you have no other repository modules, the Project API Drupal module is packaged with Project API and provides projects from Drupal CVS.'), 'error');
  }

  return system_settings_form($form);
}